package ${packageName};

import org.springframework.stereotype.Component;

import pro.shushi.pamirs.meta.annotation.Fun;
import pro.shushi.pamirs.meta.annotation.Function;
import pro.shushi.pamirs.meta.api.dto.condition.Pagination;
import pro.shushi.pamirs.meta.api.dto.wrapper.IWrapper;
import pro.shushi.pamirs.core.common.FetchUtil;

import ${apiPackageName}.${modelQueryService};
import ${modelPackageName}.${model};

import java.util.List;
/*
 * 实现类上必须@Fun才能在分布式下自动向注册中心注册服务
 * 方法上加@Function，方法才能被真正调用到
 */
@Fun(${modelQueryService}.FUN_NAMESPACE)
@Component
public class ${modelQueryService}Impl implements ${modelQueryService} {

    private IWrapper<${model}> initQueryWrapper(IWrapper<${model}> queryWrapper){
        //公共处理逻辑

        return queryWrapper;
    }

    @Override
    @Function
    public Pagination<${model}> queryPage(Pagination<${model}> page, IWrapper<${model}> queryWrapper) {
        queryWrapper = initQueryWrapper(queryWrapper);
        return new ${model}().queryPage(page,queryWrapper);
    }

    @Override
    @Function
    public List<${model}> queryListByWrapper(IWrapper<${model}> queryWrapper) {
        queryWrapper = initQueryWrapper(queryWrapper);
        return new ${model}().queryList(queryWrapper);
    }

    @Override
    @Function
    public List<${model}> queryListByEntity(${model} entity) {
        return entity.queryList();
    }

    @Override
    @Function
    public Long count(IWrapper<${model}> queryWrapper){
        queryWrapper = initQueryWrapper(queryWrapper);
        return new ${model}().count(queryWrapper);
    }

    @Override
    @Function
    public ${model} queryOneByWrapper(IWrapper<${model}> queryWrapper){
        queryWrapper = initQueryWrapper(queryWrapper);
        return new ${model}().queryOneByWrapper(queryWrapper);
    }

    @Override
    @Function
    public ${model} queryOne(${model} query){
        return query.queryOne();
    }

    <#if isCode() == true>
    @Override
    @Function
    public ${model} queryByCode(String code){
        return new ${model}().queryByCode(code);
    }

    @Override
    @Function
    public List<${model}> queryByCodes(List${"<"}String${">"} codes){
        return FetchUtil.fetchListByCodes(${model}.MODEL_MODEL,codes);
    }
    </#if>

    @Override
    @Function
    public ${model} queryById(Long id){
        return new ${model}().queryById(id);
    }

    @Override
    @Function
    public List<${model}> queryByIds(List${"<"}Long${">"} ids){
        return FetchUtil.fetchListByIds(${model}.MODEL_MODEL,ids);
    }
}
